QGIS Application - Bug report #4748

Raster reprojection in broken in qgis-master and has problems with rasters under qgis 1.7.3

2012-01-04 10:42 PM - dr -

Status: Closed

Priority: High

Assignee:

Category: Projection Support

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corruptsdata: Copied to github as #: 14617
Description

Open any shapefile (I'm not sure this bug for all shapefiles but | catch it with shapefile in attachment), then File - Project Properties -

enable on the fly CRS transformation and set "Google Mercator EPSG:900913". No effect.
QGIS version: 1.9.90+git20120104+d04bc8f~natty1

Related issues:
Duplicated by QGIS Application - Bug report # 4583: Raster reprojection error...

Closed 2011-11-30

Associated revisions

Revision b37f631a - 2012-01-06 02:17 PM - Alexander Bruy

fix #4748

Revision 95099990 - 2012-01-06 05:42 PM - Richard Duivenvoorde

better fix for #4550 change itemchanged event for simple clicked event

(also should fix #4748)

History

#1 - 2012-01-04 11:20 PM - Maxim Dubinin

This is not reprojection issue, this is interface issue, but still a bug

1. Open QGIS, add a layer, go to project properties, CRS

2. Turn on OTF, choose Google Mercator from recent -> Note that Proj string DIDN'T change

----If you click Apply, OK now - the reprojection won't turn on.

3. Choose any other CRS -> Proj string changed -> choose Google Mercator again -> Proj string changed
Apply, OK

Now back to normal.

#2 - 2012-01-04 11:33 PM - Maxim Dubinin

correction, this applies for any projection, not only Google Mercator

when you first open properties/crs, selection of any proj from recent doesn't change proj sttring and consequently doesn't reproject.
#3 - 2012-01-06 05:24 AM - Alexander Bruy
- Status changed from Open to Closed
- % Done changed from 0 to 100

Fixed in changeset commit:"b37f631abb9a3a2697e8b2f913193ed29b2c2c86".

#4 - 2012-01-06 08:15 AM - Richard Duivenvoorde

- Status changed from Closed to Reopened

hi alexander,

this does not solve it completely. There is a sort of race problem with the statechangedevents of the recent crs list.

| did an earlier try to fix this, please have a look at

https://github.com/qgis/Quantum-GIS/pull/77

Richard

#5 - 2012-01-06 09:11 AM - Richard Duivenvoorde
- Status changed from Reopened to Closed

Fixed in changeset commit:"95099990ea33ea973f5b3c316cecae6947830ec1".

#6 - 2012-01-06 09:13 AM - Alexander Bruy
- Resolution set to fixed

Pull request applied

#7 - 2012-01-11 02:56 AM - Alexander Bruy
- Status changed from Closed to Reopened
- Resolution deleted (fixed)

Problem still here. Proj4 definition updated correctly when selection changes but reprojection not work

#8 - 2012-01-14 11:39 AM - Giovanni Manghi

- Crashes QGIS or corrupts data changed from No to Yes

- Subject changed from On the fly CRS transformation doesn't work to Reprojecion in broken in qgis-master and has problems with rasters under qgis
1.7.3

| was noticing the same for rasters, see #4804, | didn't realised that was a general problem. With rasters under Windows it even causes crashes (there is a

sample dataset also in #4804).
https://github.com/qgis/Quantum-GIS/pull/77

The problem surfaces if you add first the layer, and then set the project CRS and enable OTFR. If you do the other way then it seems to work.

QGIS 1.7.3 also suffer of reprojection problems with rasters as described in other tickets -> Reprojecting a raster with a projected CRS into a geographic
CRS results in the following warning

@forward transform of
(-15345.3, 85704.6)

failed with error: latitude or longitude exceeded limit@

each time the mouse passes over the canvas.

#9 - 2012-01-14 11:39 AM - Giovanni Manghi

- Subject changed from Reprojecion in broken in gqgis-master and has problems with rasters under qgis 1.7.3 to Reprojection in broken in qgis-master
and has problems with rasters under qgis 1.7.3

#10 - 2012-01-15 06:55 AM - Alexander Bruy

- Status changed from Reopened to Closed

- Resolution set to fixed

Seems fixed in commit:9a9b53bb94.

#11 - 2012-01-16 01:09 AM - Giovanni Manghi

The vector reprojection seems fixed, the raster one is not, I'm testing it but it seems we need to reopen this or #4583

#12 - 2012-01-16 03:12 AM - Paolo Cavallini

confirmed:

trasformazione diretta of

(832.453740, 1353.648851)

PROJ.4: +proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs +to +proj=tmerc +lat_0=39.66825833333333 +lon_0=-8.133108333333334 +k=1
+X_0=0 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs

Error: latitude or longitude exceeded limits

#13 - 2012-01-16 05:16 AM - Giovanni Manghi

- Status changed from Closed to Open

- Resolution deleted (fixed)

- Subject changed from Reprojection in broken in qgis-master and has problems with rasters under qgis 1.7.3 to Raster reprojection in broken in
qgis-master and has problems with rasters under qgis 1.7.3

See also #4583

| confirm that now the message that pop ups in the canvas is slightly different but the problem is still there.

| also still confirm that with certain data (see #4583) there is a freeze.
#14 - 2012-01-26 07:54 AM - Jiirgen Fischer
Giovanni Manghi wrote:
See also #4583

| confirm that now the message that pop ups in the canvas is slightly different but the problem is still there.
| also still confirm that with certain data (see #4583) there is a freeze.

Can't reproduce the problem with master. Is master still affected?

#15 - 2012-01-27 08:37 AM - Giovanni Manghi
- File dem_clipped.tif added

Can't reproduce the problem with master. Is master still affected?

Hi Jurgen,

| just updated under both Linux and Windows and while under Windows seems ok, under Linux | still get the

forward transform of

(309.320618, 934.085281)

PROJ.4: +proj=longlat +datum=WGS84 +no_defs +to +proj=tmerc +lat_0=39.66825833333333 +lon_0=-8.133108333333334 +k=1 +x_0=0 +y_0=0
+ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs

Error: latitude or longitude exceeded limits

message. You can try the attached raster that is in the 3763 CRS. As already described the problem pop ups only when reprojecting to a geographic CRS,
like wgs84.

#16 - 2012-01-27 10:45 AM - Jiirgen Fischer

Giovanni Manghi wrote:

| just updated under both Linux and Windows and while under Windows seems ok, under Linux | still get the

forward transform of

(309.320618, 934.085281)

PROJ.4: +proj=longlat +datum=WGS84 +no_defs +to +proj=tmerc +lat_0=39.66825833333333 +lon_0=-8.133108333333334 +k=1 +x_0=0 +y_0=0
+ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs

Error: latitude or longitude exceeded limits

message. You can try the attached raster that is in the 3763 CRS. As already described the problem pop ups only when reprojecting to a geographic
CRS, like wgs84.

I'm probably missing something. How do you produce that? On current master on Linux | get:

1. Clean project (defaults to wgs84, offr off)
2. Insert dem_clipped

3. canvas zooms to dem_clipped in EPSG:3763

4. switch otfr on

5. 2 errors about empty reprojected (canvas) extent.
6. Zoom to layer

7. Content appears in EPSG:4326

#17 - 2012-01-28 06:04 AM - Giovanni Manghi
- File giac.ogv added

I'm probably missing something. How do you produce that? On current master on Linux | get:
1. Clean project (defaults to wgs84, oftfr off)
2. Insert dem_clipped
3. canvas zooms to dem_clipped in EPSG:3763
4. switch otfr on
5. 2 errors about empty reprojected (canvas) extent.
6. Zoom to layer
7. Content appears in EPSG:4326

Hi Jurgen,
see the attached screencast, this is what I'm getting in master.

Thanks!

#18 - 2012-01-28 06:42 AM - Giovanni Manghi

Hi Jurgen,
see the attached screencast, this is what I'm getting in master.

ps, in Windows it work as expected, no annoying warning pop

#19 - 2012-01-28 11:03 AM - Jiirgen Fischer

Giovanni Manghi wrote:

Hi Jurgen,
see the attached screencast, this is what I'm getting in master.

ps, in Windows it work as expected, no annoying warning pop

which version of proj.4 are you running?

#20 - 2012-01-28 11:49 AM - Giovanni Manghi

Jurgen Fischer wrote:
Giovanni Manghi wrote:

Hi Jurgen,

see the attached screencast, this is what I'm getting in master.

ps, in Windows it work as expected, no annoying warning pop

which version of proj.4 are you running?

Version: 4.7.0-2~oneiric2

#21 - 2012-01-28 12:01 PM - Jiirgen Fischer
Giovanni Manghi wrote:

| | | ps, in Windows it work as expected, no annoying warning pop
s0 you're not running valuetool on windows?

#22 - 2012-01-28 12:02 PM - Jiirgen Fischer
Jurgen Fischer wrote:
Giovanni Manghi wrote:
| | | ps, in Windows it work as expected, no annoying warning pop

S0 you're not running valuetool on windows? ;)

#23 - 2012-01-28 12:08 PM - Giovanni Manghi
- Resolution set to fixed

- Status changed from Open to Closed

Jurgen Fischer wrote:

Jirgen Fischer wrote:

Giovanni Manghi wrote:

| | | ps, in Windows it work as expected, no annoying warning pop

so you're not running valuetool on windows? ;)

damn me... | didn't had the value tool active so | didn't think it was installed
#24 - 2012-01-28 01:39 PM - Jiirgen Fischer
Giovanni Manghi wrote:

damn me... | didn't had the value tool active so | didn't think it was installed... sorry for the noise.

commit:2564e6a79 adds support for the QgsCsException, so that python plugins can also catch that exception. Now the popup comes from python and
show where the exception wasn't catched.

The following patch makes valuetool ignore that exception - no errors popping up anymore.

diff -u ~/.qgis/python/plugins/valuetool/valuewidget.py /tmp/valuewidget.py
--- /home/fischer/.qgis/python/plugins/valuetool/valuewidget.py 2012-01-28 22:35:33.578309041 +0100
+++ /tmp/valuewidget.py 2012-01-28 22:34:38.694036879 +0100
@@ -151,7 +151,11 @@
pos = mapPos
if not mapCanvasSrs == layerSrs and self.iface.mapCanvas().hasCrsTransformEnabled():
srsTransform = QgsCoordinate Transform(mapCanvasSrs, layerSrs)

- pos = srsTransform.transform(mapPos)

+ try:

+ pos = srsTransform.transform(mapPos)
+ except QgsCsException, err:

+ # ignore transformation errors

+ continue

isok,ident = layer.identify(pos)
if not isok:

continue

#25 - 2012-01-29 09:49 AM - Jiirgen Fischer

Jurgen Fischer wrote:

commit:2564e6a79 adds support for the QgsCsException, so that python plugins can also catch that exception. Now the popup comes from python
and show where the exception wasn't catched.

commit:cOcbe53a also sets the project's CRS to the layer's CRS, when it zooms to the first layer's extent...

#26 - 2012-01-29 09:55 AM - Giovanni Manghi

commit:cOcbeb53a also sets the project's CRS to the layer's CRS, when it zooms to the first layer's extent...

I think the users will find this a huge usability improvement. Thanks Jurgen.

#27 - 2012-01-31 05:11 PM - Giovanni Manghi

commit:cOcbe53a also sets the project's CRS to the layer's CRS, when it zooms to the first layer's extent...
Hi Jurgen, just tested this feature:

it works as the project CRS really changes after the first "zoom to layer" (example project in wgs84 and layer in a projected CRS). At the same | see that

the scalebar still shows degrees. If | enter the project properties and pick again the new CRS and then click "ok", then the scalebar goes ok.

#28 - 2012-02-01 04:56 AM - Giovanni Manghi

it works as the project CRS really changes after the first "zoom to layer" (example project in wgs84 and layer in a projected CRS). At the same | see

that the scalebar still shows degrees. If | enter the project properties and pick again the new CRS and then click "ok", then the scalebar goes ok.

Hi Jurgen, let me know if you want me to file a separate ticket about this issue.

Files

admin.7z 64.3 KB 2012-01-04 dr-
dem_clipped.tif 498 KB 2012-01-27 Giovanni Manghi
giac.ogv 2.7 MB 2012-01-28 Giovanni Manghi
